package common

import anorm.{NamedParameter, Row, SimpleSql}

/** Macro to generate SQL Query from case classes
  * Use sbt -Dcommon.macro.debug=true to debug generated code
  */
object CrudMacro {

  import scala.language.experimental.macros
  import scala.reflect.macros.whitebox

  trait ColumnNaming extends (String => String) {
    def apply(property: String): String
  }

  object LispCase extends ColumnNaming {
    private val re = "[A-Z]+".r
    override def apply(property: String): String =
      re.replaceAllIn(property, { m => s"-${m.matched.toLowerCase}" })
        .replace('_', '-')
  }

  object SnakeCase extends ColumnNaming {
    private val re = "[A-Z]+".r
    override def apply(property: String): String =
      re.replaceAllIn(property, { m => s"_${m.matched.toLowerCase}" })
  }

  def genericQueryImpl[T: c.WeakTypeTag](c: whitebox.Context)(
      t: c.Expr[T],
      table: c.Expr[String],
      ids: c.Expr[Set[String]],
      excludeColumns: c.Expr[Set[String]],
      excludeId: c.Expr[Boolean],
      naming: c.Expr[ColumnNaming],
      sqlOperation: c.Expr[SQLOperation]
  ): c.Expr[SimpleSql[Row]] = {
    import c.universe._

    val tpe                      = c.weakTypeTag[T].tpe
    @inline def abort(m: String) = c.abort(c.enclosingPosition, m)

    if (!tpe.typeSymbol.isClass || !tpe.typeSymbol.asClass.isCaseClass) {
      abort(s"case class expected: ${tpe}")
    }

    val params: List[(TermName, String, String)] = tpe.decls.collect {
      case param if param.isMethod && param.asMethod.isCaseAccessor =>
        (
          param.asTerm.name,
          param.name.decodedName.toString,
          tpe.decl(param.name).typeSignature.toString
        )
    }.toList

    val columns = params.map(p => {
      val cn = p._2
      q"$cn -> $naming($cn)"
    })

    val binds = params.map(p => {
      val name = p._1
      val key  = p._2
      q"$key -> $t.$name"
    })

    val expr = c.Expr[SimpleSql[Row]] {
      q"$sqlOperation($table, $ids, $excludeColumns, $excludeId, Map(..$columns), List(..$binds))"
    }
    if (debugEnabled) {
      val sql = show(expr).replaceAll("\\.\\$minus\\$greater", " -> ")
      c.echo(c.enclosingPosition, s"SQL generated for $tpe: $sql")
    }
    expr
  }

  type SQLOperation = (
      String,
      Set[String],
      Set[String],
      Boolean,
      Map[String, String],
      Seq[NamedParameter]
  ) => SimpleSql[Row]

  private def filterIdFromColumns(
      excludeId: Boolean,
      ids: Set[String],
      excludeColumns: Set[String],
      columns: Map[String, String]
  ): Map[String, String] = {
    if (excludeId)
      columns
        .filter(c => { !ids.contains(c._1) })
        .filterNot(c => excludeColumns.contains(c._1))
    else {
      columns.filterNot(c => excludeColumns.contains(c._1))
    }
  }

  def SQLInsert(
      table: String,
      ids: Set[String],
      excludeColumns: Set[String],
      excludeId: Boolean,
      columns: Map[String, String],
      np: Seq[NamedParameter]
  ): SimpleSql[Row] = {
    val filtered = filterIdFromColumns(excludeId, ids, excludeColumns, columns)
    val sql = "INSERT INTO " + table + "(" + filtered
      .map("\"" + _._2 + "\"")
      .mkString(", ") + ")" +
      "VALUES (" + filtered.map("{" + _._1 + "}").mkString(", ") + ");"

    anorm.SQL(sql).on(np: _*)
  }

  def SQLUpdate(
      table: String,
      ids: Set[String],
      excludeColumns: Set[String],
      excludeId: Boolean,
      columns: Map[String, String],
      np: Seq[NamedParameter]
  ): SimpleSql[Row] = {
    val filtered = filterIdFromColumns(excludeId, excludeColumns, ids, columns)
    val whereClause =
      ids.map(id => "\"" + columns(id) + "\" = {" + id + "}").mkString(" AND ")
    val sql = "UPDATE " + table + " SET " + filtered
      .map(c => { "\"" + c._2 + "\" = {" + c._1 + "}" })
      .mkString(", ") +
      " WHERE " + whereClause
    anorm.SQL(sql).on(np: _*)
  }

  /** Generate a SimpleSql[Row] from the given case class
    * @param t the object (of type T) to get the value from
    * @param table the table name to persist the object t
    * @param ids the set of field name representing the id
    * @param excludeColumns the set of field name to be excluded in the query insert or update (eg. when column is autogenerated)
    * @param excludeId set to true if you don't want to update the id field (set to true if id is autogenerated)
    * @param naming the naming pattern to use
    * @param sqlOperation the SqlOperation to perform (one of SQLUpdate or SQLInsert)
    * @tparam T the type of the given class
    * @return
    */
  def query[T](
      t: T,
      table: String,
      ids: Set[String],
      excludeColumns: Set[String],
      excludeId: Boolean,
      naming: CrudMacro.ColumnNaming,
      sqlOperation: CrudMacro.SQLOperation
  ): SimpleSql[Row] = macro genericQueryImpl[T]

  private lazy val debugEnabled =
    Option(System.getProperty("common.macro.debug"))
      .filterNot(_.isEmpty)
      .map(_.toLowerCase)
      .map { v =>
        "true".equals(v) || v.substring(0, 1) == "y"
      }
      .getOrElse(false)
}
